<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="团队人员ID" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入团队人员ID" />
      </el-form-item>
      <el-form-item label="团队人员姓名" prop="name">
        <el-input v-model="formData.name" placeholder="请输入团队人员姓名" />
      </el-form-item>
      <el-form-item label="团队人员手机号码" prop="mobile">
        <el-input v-model="formData.mobile" placeholder="请输入团队人员手机号码" />
      </el-form-item>
      <el-form-item label="团队人员来源" prop="source">
        <el-input v-model="formData.source" placeholder="请输入团队人员来源" />
      </el-form-item>
      <el-form-item label="团队用户当前佣金" prop="integralId">
        <el-input v-model="formData.integralId" placeholder="请输入团队用户当前佣金" />
      </el-form-item>
      <el-form-item label="团队用户当前身价(等级)" prop="socialStatus">
        <el-radio-group v-model="formData.socialStatus">
          <el-radio label="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="团队用户当前点数" prop="socialStatusPoint">
        <el-input v-model="formData.socialStatusPoint" placeholder="请输入团队用户当前点数" />
      </el-form-item>
      <el-form-item label="用户类型" prop="categoryId">
        <el-input v-model="formData.categoryId" placeholder="请输入用户类型" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DuserApi, DuserVO } from '@/api/system/distri/duser'

/** 推荐用户 表单 */
defineOptions({ name: 'DuserForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  userId: undefined,
  name: undefined,
  mobile: undefined,
  source: undefined,
  integralId: undefined,
  socialStatus: undefined,
  socialStatusPoint: undefined,
  categoryId: undefined
})
const formRules = reactive({
  userId: [{ required: true, message: '团队人员ID不能为空', trigger: 'blur' }],
  name: [{ required: true, message: '团队人员姓名不能为空', trigger: 'blur' }],
  mobile: [{ required: true, message: '团队人员手机号码不能为空', trigger: 'blur' }],
  integralId: [{ required: true, message: '团队用户当前佣金不能为空', trigger: 'blur' }],
  categoryId: [{ required: true, message: '用户类型不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await DuserApi.getDuser(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as DuserApi.DuserVO
    if (formType.value === 'create') {
      await DuserApi.createDuser(data)
      message.success(t('common.createSuccess'))
    } else {
      await DuserApi.updateDuser(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    userId: undefined,
    name: undefined,
    mobile: undefined,
    source: undefined,
    integralId: undefined,
    socialStatus: undefined,
    socialStatusPoint: undefined,
    categoryId: undefined
  }
  formRef.value?.resetFields()
}
</script>